var Validation  = function()
{
    //constructor
}
Validation.prototype = {
    'required'  : function(arg)
    {
        return !!(arg[1]);
    },
    'minlength' : function(arg)
    {
        if ( !arg[1] ) return true;
        if ( !arg[2] ) return false;
        return parseInt('0' + arg[2], 10) <= arg[1].length;
    },
    'maxlength' : function(arg)
    {
        if ( !arg[1] ) return true;
        if ( !arg[2] ) return false;
        return parseInt('0' + arg[2], 10) >= arg[1].length;
    },
    'min'   : function(arg)
    {
        if ( !arg[1] ) return true;
        if ( !arg[2] ) return false;
        return parseInt('0' + arg[2], 10) <= parseInt('0' + arg[1], 10);
    },
    'max'   : function(arg)
    {
        if ( !arg[1] ) return true;
        if ( !arg[2] ) return false;
        return parseInt('0' + arg[2], 10) >= parseInt('0' + arg[1], 10);
    },
    'regexp'    : function(arg)
    {
        if ( !arg[1] ) return true;
        if ( !arg[2] ) return false;
        var strRegex   = arg[2];

        var flag    = '';
        if ( strRegex.match(/^@(.*)@([igm]*)$/) ) {
            strRegex    = RegExp.$1;
            flag    = RegExp.$2;
        }

        var regex   = new RegExp(strRegex, flag);
        return regex.test(arg[1]);
    },
    'regex' : function ( arg )
    {
        return this.regexp(arg);
    },
    'digits'    : function(arg)
    {
        if ( !arg[1] ) return true;
        return /^\d+$/.test(arg[1]);
    },
    'email' :function(arg)
    {
        if ( !arg[1] ) return true;
        return /^((([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+(\.([a-z]|\d|[!#\$%&'\*\+\-\/=\?\^_`{\|}~]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])+)*)|((\x22)((((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(([\x01-\x08\x0b\x0c\x0e-\x1f\x7f]|\x21|[\x23-\x5b]|[\x5d-\x7e]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(\\([\x01-\x09\x0b\x0c\x0d-\x7f]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]))))*(((\x20|\x09)*(\x0d\x0a))?(\x20|\x09)+)?(\x22)))@((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?$/i.test(arg[1]);
    },
    'url'   :function(arg)
    {
        if ( !arg[1] ) return true;
        return /^(https?|ftp):\/\/(((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:)*@)?(((\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]))|((([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|\d|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.)+(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])*([a-z]|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])))\.?)(:\d*)?)(\/((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)+(\/(([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)*)*)?)?(\?((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|[\uE000-\uF8FF]|\/|\?)*)?(\#((([a-z]|\d|-|\.|_|~|[\u00A0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF])|(%[\da-f]{2})|[!\$&'\(\)\*\+,;=]|:|@)|\/|\?)*)?$/i.test(arg[1]);
    },
    'equalTo'   : function(arg)
    {
        if ( !arg[2] ) return false;
        var key = arg[2];
        $cmp    = $(':input[@name="' + key + '"]');
        if ( !$cmp.size() ) return false; // check
        return $cmp.val() == arg[1];
    }
}
